*
* sav.s
*
* v0.2 14/12/01
*
* Rclpar pushes the Library data Upar, creating it if needed
* There are also routines to do pushs, errors, etc...
*

ASSEMBLE
	CON(1)		8
RPL
NULLNAME Rclpar
::
  FALSE
CODE
	GOSBVL	=SAVPTR
	D0=(5)	=IOC
	A=DAT0	P
	?ABIT=0	3			wire serial port enable
	GOYES	+
	GOVLNG	=GETPTRLOOP
+
	GOSBVL	=GETPTR
	LC(5)	=TRUE
	DAT1=C	A			repl
	GOVLNG	=Loop
ENDCODE
  IT SerialInit
  ID Upar
  FALSE
CODE
	GOSBVL	=SAVPTR

* looks the beginning of Upar : Library data ?

	D1=D1+	5
	A=DAT1	A
	D1=A	A
	A=DAT1	A
	LC(5)	=DOEXT0
	?A#C	A
	GOYES	+

* Checks the size

	D1=D1+	5
	A=DAT1	A
	LC(5)	(=endbuffers)-5
	?A#C	A
	GOYES	+

* looks a bit further to check in case it is a fake Upar (or an old version one)

	AD1EX	A
	LC(5)	(config_paquet)-(upardonn)+(sizeblank)+5
	A=C+A	A
	D1=A	A
	A=DAT1	A
	C=A	A
	LC(4)	_LCP
	?A#C	A
	GOYES	+

	GOVLNG	=GETPTRLOOP
+
	GOSBVL	=GETPTR
	LC(5)	=TRUE
	DAT1=C	A
	GOVLNG	=Loop
ENDCODE
  IT
  ::
CODE
* get room for buffers and saves
	GOSBVL	=SAVPTR
	LC(5)	=endbuffers
	GOSBVL	=GETTEMP	gets C nibbles -> @D0
	CD0EX	A
	R4=C.F	A
	CD0EX	A

* header
	LC(5)	=DOEXT0		library data
	DAT0=C	A
	D0+	5

	LC(5)	(endbuffers)-5	~8 Ko buffers
	DAT0=C	A
	D0+	5

* blank saves
	A=0	P
	LC(3)	(sizeblank)-1
-
	DAT0=A	P
	D0+	1

	C=C-1	X
	GONC	-

	AD0EX	A
	D1=A				destination in D1

* copy "ready to send" packets  (XXX must disappear !)
	A=PC	A
-
	LC(5)	(upardonn)-(-)
	A=A+C	A
	D0=A	A			source in D0
	LC(5)	(finupardonn)-(upardonn)-1

	GOSBVL	=MOVEDOWN		COPY !

* reset default port (it's the best place !)
	A=R4.F	A
	LC(5)	(defaultport)+10
	C=C+A	A
	D1=C

	LC(4)	1024-1
	DAT1=C	4

	LC(5)	(sizeblank)+(AdresseIP_paquet)-(upardonn)+10
	C=C+A	A
	D1=C
	C=DAT1	8
	D=C	W

	LC(5)	(ipanous)+10
	C=C+A	A
	D1=C
	C=D	W
	DAT1=C	8

*	A=R4.F	A

	GOSBVL	=GETPTR

* replace the name by the content
	DAT1=A	A
	GOVLNG	=Loop
ENDCODE
RPL
    ' ID Upar SysSTO ID Upar
  ;
  _b_fl_Verbose TestUserFlag
  _b_fl_NBlock TestUserFlag
  _b_fl_Readln TestUserFlag
;

* saveregs saves registers, ie ip adresses, etc...
* beware, Upar must be on level 1

ASSEMBLE
=saveregs
	A=DAT1	A			Read only one line ?
	LC(5)	=TRUE
	ST=1	_b_st_Readln
	?C=A	A
	GOYES	+
	ST=0	_b_st_Readln
+
	D1+	5			drop
	D+1	A

	A=DAT1	A			Non Block mode ?
	ST=1	_b_st_NBlock
	?C=A	A
	GOYES	+
	ST=0	_b_st_NBlock
+
	D1+	5			drop
	D+1	A

	A=DAT1	A
	ST=1	_b_st_Verbose
	?C=A	A
	GOYES	+
	ST=0	_b_st_Verbose
+
	D1+	5			drop
	D+1	A

	A=DAT1	A			address Upar
	A=A+CON	A,10			points at the beginning of data
	R4=A.F	A
	D1+	5			drop
	D+1	A

	GOVLNG	=SAVPTR


=ckpppisconn
	A=R4.F	A
	D0=A	A
	D0+	(ipconnected)

	A=DAT0	P
	?A#0	P
	RTNYES

	LC(5)	XErr_Disconn
	GOTO	=erreur


* drop ends the program dropping the last level (beware : no check !)

=drop
	GOSBVL	=GETPTR
	D1=D1+	5			drop
	D=D+1	A
	GOSBVL	=SAVPTR
	GOTO	exit

* repl just replaces the last level by @A

=repl
	GOSBVL	=GETPTR
	DAT1=A	A			replaces the adresse
	GOSBVL	=SAVPTR
	GOTO	exit

* push pushes the objet @A in the stack

=push
	GOSBVL	=GETPTR
	?D=0	A
	GOYES	fullmem
	D1=D1-	5			push
	D=D-1	A
	DAT1=A	A
	GOVLNG	=SAVPTR

=fullmem
	LC(5)	XErr_Nomem
	GOTO	erreur



* exit restores registers

=exit
	P=	0
	GOVLNG	=GETPTRLOOP


* erreur launches the error message number C

=erreur
	A=C	A
	GOSBVL	=GETPTR
	C=A	A
	GOVLNG	=GPErrjmpC
RPL
