*
* chat.s
*
* v0.2 01/12/01
*
* implements CHAT (see man chat)
*

ASSEMBLE
	CON(1)		8
RPL
DEFINE @Question	1GETLAM
DEFINE !Question	1PUTLAM
DEFINE @Size		2GETLAM
DEFINE !Size		2PUTLAM
DEFINE @Received	3GETLAM
DEFINE !Received	3PUTLAM
DEFINE @DispX		4GETLAM
DEFINE !DispX		4PUTLAM
DEFINE PENULTLINE	FIFTYTHREE
DEFINE LASTLINE		FIFTYNINE
DEFINE VLASTLINE	SIXTYTHREE
DEFINE VLASTLINE2	SIXTYFOUR
DEFINE VLASTCOL		BINT_130d
DEFINE VLASTCOL2	BINT_131d
DEFINE MAXCHARS+1	SIXTYTWO

xNAME CHAT
::
 CK1&Dispatch list ::

 SerialInit
 DUP NULLCOMP?			( if { }, don't do anything more ! )
 ITE
 :: DROP ;
 ::
  ZERO NULL$ ZERO NULL$
  { NULLLAM NULLLAM NULLLAM NULLLAM } BIND

  _b_fl_Verbose TestUserFlag IT
  ::
   ClrDA1IsStat			( don't show clock )
   RECLAIMDISP			( clears text but XXX : makes it 131x56 )
   TURNMENUOFF			( this makes text 131x64 )
  ;
  INNERCOMP
  reversym
  #1+_ONE_DO (DO)
   DUPTYPECSTR? ITE
   ::
    DUP NULL$? ITE
    :: DROP ;			( no question ? no wait )
    ::

     _b_fl_Verbose TestUserFlag IT
     ::
( Displays the question )
      LASTLINE FIVE BLANKIT		( clears 5 lines from LASTLINE )
      DUP MAXCHARS+1 1_#1-SUB$ $>grob
      ZEROZERO VLASTCOL2 FIVE SUBGROB HARDBUFF ZERO LASTLINE GROB!
     ;
     DUP LEN$
     !Size !Question
     @Received CHR_Space >H$
     BEGIN
      ?ATTNQUIT
      DUP @Question ONE POS$
      DUP#0<>
      ITE
      ::
       @Size #+ LAST$ FALSE	( found it => delete it )
      ;
      ::
       DROP TRUE
      ;
     WHILE
      DUP LEN$ @Size #<
      ITE

      ::
( too narrow to be the question, let's read more ! )
       UARTBUFLEN #0=
       IT
       ::
        ERROR@ JstGETTHEMSG DISPROW6
       ;
       GETSERIAL DROP

       _b_fl_Verbose TestUserFlag IT
       ::
( got something... let's show it, with scrolling screen )
        DUP
        BEGIN
         DUP CHR ^J ONE POSCHR #0<>
        WHILE
         SEP$NL						( picks one line )
         VLASTCOL @DispX #<				( still within screen ?)
         ITE DROP
         ::
          MAXCHARS+1 1_#1-SUB$ $>grob ZEROZERO VLASTCOL2 @DispX #- FIVE SUBGROB
          HARDBUFF @DispX PENULTLINE GROB!
         ;
         HARDBUFF ZERO SIX VLASTCOL2 LASTLINE SUBGROB
         HARDBUFF ZEROZERO GROB!			( and scroll screen )
         HARDBUFF ZERO PENULTLINE VLASTCOL LASTLINE GROB!ZERODRP
         ZERO !DispX
        REPEAT
        VLASTCOL @DispX #<
        ITE DROP
        ::
         MAXCHARS+1 1_#1-SUB$ $>grob ZEROZERO VLASTCOL2 @DispX #- FIVE SUBGROB
         DUP GROBDIMw SWAP
         HARDBUFF @DispX PENULTLINE GROB!
         @DispX #+ !DispX
        ;
       ;
( and add it )
       &$
      ;

      ::
( too big, let's shrink it )
       DUP LEN$ @Size #- #2+ LAST$
      ;

     REPEAT
     !Received
    ;
    INDEX@ #1+ DUP INDEXSTO ISTOP@ #<
    IT
    ::
     _b_fl_Verbose TestUserFlag IT
     ::
      LASTLINE FIVE BLANKIT		( clears 5 lines from LASTLINE )
      DUP MAXCHARS+1 1_#1-SUB$ $>grob
      ZEROZERO VLASTCOL2 FIVE SUBGROB HARDBUFF ZERO LASTLINE GROB!
     ;
     PUTSERIAL NOT		( tell the answer )
     IT
     ::
      ERRORSTO ERRJMP
     ;
    ;
   ;
   :: DROP ;
  LOOP
  _b_fl_Verbose TestUserFlag IT
  :: ClrDAsOK ;			( redraw screen )
(  :: SetDAsTemp ;		( freeze all display areas )
  ABND
 ;

 ;
;
