*
* main.s
*
* v0.2 01/01/02
*
* user commands for PPP connection
*

*
*
* Pppon negociates the connection
*
*

ASSEMBLE
	CON(1)		8
RPL
xNAME PPPON
::
  CK0 SerialInit Rclpar
CODE
	GOSUBL	saveregs

sendlcpreq
* in case the host's tty is locked.
	LA(2)	_XON
	GOSUBL	=sendchar

	A=R4.F	A
	D0=A

* IP layer is down
	D0+	ipconnected
	LC(1)	_IP_notconnected
	DAT0=C	P

* toss until next frame
	D0+	(pppstatus)-(ipconnected)
	LC(1)	HDLC_TOSSING
	DAT0=C	P

* sets asyncmap to ALL !
	D0=D0+	(pppasyncmap)-(pppstatus)
	LC(8)	#FFFFFFFF
	DAT0=C	8

* sets mtu to default
	D0+	(mtu)-(pppasyncmap)
	LC(5)	_defmtu
	DAT0=C	A

* clears FCS error number
	D0=D0+	(fcserror)-(mtu)
	C=0	A
	DAT0=C	A

* automates at the very beginning
	D0=D0+	(pppstate)-(fcserror)
	LC(1)	_Establish
	DAT0=C	P

	D0=D0+	(lcpstate)-(pppstate)
	LC(1)	_Req_Sent
	DAT0=C	P

* sets timeouts counter
	D0=D0+	(cptimeout)-(lcpstate)
	LC(1)	_num_retries
	DAT0=C	P

* so as to launch negociation
	GOSUB	=lcpscr

* wait until negociation is done, or excessive timeouts happened
	GOSUBL	=ztick
-
	GOSUBL	=tick
	GONC	+
	GOSUB	=lcptimeout
	GOSUBL	=ztick
+
	GOSUBL	=rechdlc

	A=R4.F	A
	LC(5)	ipconnected
	C=C+A	A
	D0=C
	A=DAT0	P
	LC(1)	_IP_connected
	?A#C	P
	GOYES	-

	GOLONG	=exit

ENDCODE
;

ASSEMBLE
	CON(1)		8
RPL
xNAME PPPOFF
::
  CK0
  Rclpar
CODE
	GOSUBL	=saveregs

* IP layer is now down
	A=R4.F	A
	LC(5)	ipconnected
	C+A	A
	D0=C
	LC(1)	_IP_notconnected
	DAT0=C	P

* PPP layer is terminating
	D0+	(pppstate)-(ipconnected)
	LC(1)	_Terminate
	DAT0=C	P			Terminating

* set timeouts counter
	D0+	(cptimeout)-(pppstate)
	LC(1)	_num_retries
	DAT0=C	P

* so as to launch termination
	GOSUB	=send_Term_Req

* wait until termination is now, or excessive timeouts happened
	GOSUBL	=ztick
-
	GOSUBL	=tick
	GONC	++
	A=R4.F	A
	LC(5)	cptimeout
	C+A	A
	D0=C
	C=DAT0	P
	?C#0	P
	GOYES	+

* excessive timeouts, let's give up.
	LC(5)	XErr_Time
	GOTOL	=erreur

+
	GOSUB	=send_Term_Req
	GOSUBL	=ztick
++
	GOSUBL	=rechdlc

	A=R4.F	A
	LC(5)	pppstate
	C=C+A	A
	D0=C
	A=DAT0	P
	LC(1)	_Dead
	?A#C	P
	GOYES	-

	GOLONG	=exit

ENDCODE
  CLOSEUART
;
